import Product from './components/Product.vue';
import ProductInfo from './components/ProductInfo.vue';
import ProductGallery from './components/ProductGallery.vue';

// Declare install function executed by Vue.use()
export function install(Vue) {
    if (install.installed) return;
    install.installed = true;
    Vue.component('Product', Product);
    Vue.component('ProductInfo', ProductInfo);
    Vue.component('ProductGallery', ProductGallery);
}

// Create module definition for Vue.use()
const plugin = {
    install,
};

// Auto-install when vue is found (eg. in browser via <script> tag)
let GlobalVue = null;
if (typeof window !== 'undefined') {
    GlobalVue = window.Vue;
} else if (typeof global !== 'undefined') {
    GlobalVue = global.Vue;
}
if (GlobalVue) {
    GlobalVue.use(plugin);
}

export default {
    install,
    Product,
    ProductInfo,
    ProductGallery,
};
